// file: $isip/class/algo/Cepstrum/cep_01.cc
// version: $Id: cep_01.cc,v 1.8 2002/07/17 21:59:45 parihar Exp $
//

// isip include files
//
#include <Console.h>
#include "Cepstrum.h"

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean Cepstrum::debug(const unichar* msg_a) const {

  // declare local variables
  //  
  String value;
  String output;
  String empty_str;

  // output the information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);

  // increase the indentation
  //
  Console::increaseIndention();
  
  // display the algorithm name 
  //
  output.debugStr(name(), empty_str, L"algorithm_d",
                  ALGO_MAP.getName((long)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((long)implementation_d));
  Console::put(output);

  // display the FourierTransform object
  //
  ft_d.debug(L"ft_d");

  // display the order
  //
  value.assign(order_d);
  output.debugStr(name(), empty_str, L"order_d", value);
  Console::put(output);

  // display the minimum amplitude
  //
  value.assign(min_amp_d);
  output.debugStr(name(), empty_str, L"min_amp_d", value);
  Console::put(output);

  // display the minimum amplitude flag
  //
  value.assign(flag_min_amp_d);
  output.debugStr(name(), empty_str, L"flag_min_amp_d", value);
  Console::put(output);

  // debug level
  //
  output.debugStr(name(), msg_a, L"debug_level_d",
		  debug_level_d.getName());
  Console::put(output);
  
  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");
  
  // decrease indention
  //
  Console::decreaseIndention();
  
  // exit gracefully
  //
  return true;
}
