// file: $isip/class/algo/FourierTransform/ft_01.cc
// version: $Id: ft_01.cc,v 1.7 2002/05/31 21:57:28 picone Exp $
//

// isip include files
//
#include "FourierTransform.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean FourierTransform::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;
  String empty_str;

  // output the information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm name and data type
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
		  ALGO_MAP.getName((long)algorithm_d));
  Console::put(output);

  output.debugStr(name(), msg_a, L"implementation_d",
		  IMPL_MAP.getName((long)implementation_d));
  Console::put(output);  

  output.debugStr(name(), msg_a, L"direction_d",
		  DIRE_MAP.getName((long)direction_d));
  Console::put(output);  

  output.debugStr(name(), msg_a, L"resolution_d",
		  RESO_MAP.getName((long)resolution_d));
  Console::put(output);  
  
  output.debugStr(name(), msg_a, L"normalization_d",
		  NORM_MAP.getName((long)normalization_d));
  Console::put(output);  

  // display the input length
  //
  value.assign(ilen_d);
  output.debugStr(name(), msg_a, L"ilen_d", value);
  Console::put(output);

  // display the output length
  //
  value.assign(olen_d);
  output.debugStr(name(), msg_a, L"olen_d", value);
  Console::put(output);
  
  // display the order
  //
  value.assign(order_d);
  output.debugStr(name(), msg_a, L"order_d", value);
  Console::put(output);
  
  // display valid flag
  //
  value.assign(is_valid_d);
  output.debugStr(name(), msg_a, L"is_valid_d", value);
  Console::put(output);

  // display the debug level
  //
  output.debugStr(name(), msg_a, L"debug_level_d",
		  debug_level_d.getName());
  Console::put(output);

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");
  
  // decrease indention
  //
  Console::decreaseIndention();
 
  // exit gracefully
  //
  return true;
}
