// file: $isip/class/algo/Reflection/refl_01.cc
// version: $Id: refl_01.cc,v 1.3 2002/01/12 05:51:08 gao Exp $
//

// isip include files
//
#include "Reflection.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean Reflection::debug(const unichar* msg_a) const {

  // declare local variables
  //  
  String value;
  String output;

  // output the information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();
  
  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
		  ALGO_MAP.getName((long)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((long)implementation_d));
  Console::put(output);

  // display the order
  //
  value.assign(order_d);
  output.debugStr(name(), msg_a, L"order_d", value);
  Console::put(output);
  
  // display the dynamic range threshold
  //
  value.assign(dyn_range_d);
  output.debugStr(name(), msg_a, L"dyn_range_d", value);
  Console::put(output);

  // display the debug level
  //
  value.assign((long) debug_level_d);
  output.debugStr(name(), msg_a, L"debug_level_d", value);
  Console::put(output);

  // decrease indention
  //
  Console::decreaseIndention();
  
  // exit gracefully
  //
  return true;
}
