// file: $isip/class/mmedia/AudioFile/adf_12.cc
// version: $Id: adf_12.cc,v 1.2 2002/03/08 17:37:53 gao Exp $
//

// isip include files
//
#include "AudioFile.h"

// method: readWavData
//
// arguments:
//  Vector<VectorFloat>& data: (output) the audio data
//  long ctag: (input) the channel to read
//  long start_samp: (input) the start sample of the audio data
//  long num_samp: (input) number of samples
//  
// return: the number of samples read
//
// this method gets data from the raw audio file and put each channel data
// into a VectorFloat
//
long AudioFile::readWavData(Vector<VectorFloat>& data_a, long ctag_a,
			    long start_samp_a, long num_samp_a) {
  
  // for binary read
  //
  if (file_format_d != WAV) {
    Error::handle(name(), L"readWavData", ERR_TYPE, __FILE__, __LINE__);
    return -1;
  }
  
  // not implemented yet
  //
  Error::handle(name(), L"readWavData", Error::NOT_IMPLEM,
		       __FILE__, __LINE__);
  
  // exit gracefully
  //
  return -1;
}

// method: writeWavData
//
// arguments:
//  Vector<VectorFloat>& data: (input) the audio data to write
//  long ctag: (input) channel tag
//  
// return: the number of elements written
//
// this method writes the audio data to a raw audio file
//
long AudioFile::writeWavData(Vector<VectorFloat>& data_a,
			       long ctag_a) {
  
  // write to wav file
  //
  if (file_format_d != WAV) {
    return Error::handle(name(), L"writeWavData", ERR, __FILE__, __LINE__);
  }

  // not implemented
  //
  return Error::handle(name(), L"writeWavData", ERR, __FILE__, __LINE__);

  // exit gracefully
  //
  return true;
}
