// file: $isip/class/mmedia/AudioFile/adf_13.cc
// version: $Id: adf_13.cc,v 1.2 2002/03/08 17:37:53 gao Exp $
//

// isip include files
//
#include "AudioFile.h"

// method: readSphereData
//
// arguments:
//  Vector<VectorFloat>& data: (output) the audio data
//  long ctag: (input) the channel to read
//  long start_samp: (input) the start sample of the audio data
//  long num_samp: (input) the number of samples to read
//  
// return: the number of samples read
//
// this method gets data from the raw audio file and put each channel data
// into a VectorFloat
//
long AudioFile::readSphereData(Vector<VectorFloat>& data_a,
			       long ctag_a, long start_samp_a,
			       long num_samp_a) {
  
  // for binary read
  //
  if (file_format_d != SPHERE) {
    Error::handle(name(), L"readSphereData", ERR_TYPE,
		  __FILE__, __LINE__);
    return -1;
  }
  
  // not implemented yet
  //
  Error::handle(name(), L"readSphereData", Error::NOT_IMPLEM,
		__FILE__, __LINE__);
  
  // exit gracefully
  //
  return -1;
}

// method: writeSphereData
//
// arguments:
//  Vector<VectorFloat>& data: (input) the audio data to write
//  long ctag: (input) channel tag
//  
// return: the number of elements written
//
// this method writes the audio data to a sphere audio file
//
long AudioFile::writeSphereData(Vector<VectorFloat>& data_a,
			       long ctag_a) {
  
  // write to sphere file
  //
  if (file_format_d != SPHERE) {
    return Error::handle(name(), L"writeSphereData", ERR, __FILE__, __LINE__);
  }

  // not implemented
  //
  return Error::handle(name(), L"writeSphereData", ERR, __FILE__, __LINE__);

  // exit gracefully
  //
  return true;
}
