// file: $isip/class/asr/LanguageModel/lm_06.cc
// version: $Id: lm_06.cc,v 1.9 2002/07/25 17:42:19 alphonso Exp $
//

// isip include files
//
#include "LanguageModel.h"
#include <Console.h>

// method: getLevel
//
// arguments:
//     SearchLevel& search_level_a: (output) search level
//     long level_num_a: (input) index of the level wanted
//
// return: a boolean value indicating status 
//
// this method outputs a search level according to a given index
//
boolean LanguageModel::getLevel(SearchLevel& search_level_a, long index_a) {

  if((index_a > num_level_d) || (index_a < 0)) { 
    return Error::handle(index_a, L"invalid", Error::TEST,
			 __FILE__, __LINE__);
  }
  else {
    search_level_a.assign(search_levels_d(index_a));
    if (search_levels_d(index_a).getNumSubGraphs() > 0) {
      search_level_a.setNumSubGraphs(search_levels_d(index_a).getNumSubGraphs());
      for(int i=0; i < search_levels_d(index_a).getNumSubGraphs(); i++) {      
	search_level_a.setSubGraph(i, search_levels_d(index_a).getSubGraph(i));
      }
    }
    search_level_a.setSymbolTable(search_levels_d(index_a).getSymbolTable());
    search_level_a.setNonSpeechSymbolTable(search_levels_d(index_a).getNonSpeechSymbolTable());
  }

  // gracefully exit
  //
  return true;
}
