// file: $isip/class/search/History/hist_02.cc
// version: $Id: hist_02.cc,v 1.6 2003/04/19 19:22:42 alphonso Exp $
//

// isip include files
//
#include "History.h"
#include <Console.h>

// method: diagnose
//
// arguments:
//  Integral::DEBUG level: (input) debug level for diagnostics
//
// return: a boolean value indicating status
//
// this is the diagnose method
//
boolean History::diagnose(Integral::DEBUG level_a) {

  //----------------------------------------------------------------------
  //
  // 0. preliminaries
  //
  //----------------------------------------------------------------------

  // output the class name
  //
  if (level_a > Integral::NONE) {
    SysString output(L"diagnosing class ");
    output.concat(CLASS_NAME);
    output.concat(L": ");
    Console::put(output);
    Console::increaseIndention();
  }

  //---------------------------------------------------------------------
  //
  // 1. required public methods
  //
  //---------------------------------------------------------------------


  // set indentation
  //
  if (level_a > Integral::NONE) {
    Console::put(L"testing required public methods...\n");
    Console::increaseIndention();
  }

  // reset indentation
  //
  if (level_a > Integral::NONE) {
    Console::decreaseIndention();
  }

  //---------------------------------------------------------------------
  //
  // 2. class-specific public methods
  //
  //---------------------------------------------------------------------

  // set indentation
  //
  if (level_a > Integral::NONE) {
    Console::put(L"testing class-specific public methods...\n");
    Console::increaseIndention(); 
  }

  // declare variables
  //
  History hist_00;

  GraphVertex<SearchNode>* vert_00 = new GraphVertex<SearchNode>();
  GraphVertex<SearchNode>* vert_01 = new GraphVertex<SearchNode>();
  GraphVertex<SearchNode>* vert_02 = new GraphVertex<SearchNode>();

  // set up the context
  //
  Context* cont_01 = (Context*)NULL;
  Context cont_00(3, 2);
  
  cont_00.assignAndAdvance((ulong)vert_00);
  cont_00.assignAndAdvance((ulong)vert_01);
  cont_00.assignAndAdvance((ulong)vert_02);
  
  if (!hist_00.push(&cont_00)) {
    return Error::handle(name(), L"diagnose", Error::TEST, __FILE__, __LINE__);
  }
  
  if (!hist_00.peek()->eq(cont_00)) {
    return Error::handle(name(), L"diagnose", Error::TEST, __FILE__, __LINE__);
  }

  cont_01 = hist_00.pop();

  if (!cont_01->eq(cont_00)) {
    return Error::handle(name(), L"diagnose", Error::TEST, __FILE__, __LINE__);
  }
  
  // clean up
  //
  delete vert_00;
  delete vert_01;
  delete vert_02;
  
  // reset indentation
  //
  if (level_a > Integral::NONE) {
    Console::decreaseIndention();
  }
  
  //---------------------------------------------------------------------
  //
  // 4. print completion message
  //
  //---------------------------------------------------------------------

  // reset indentation
  //
  if (level_a > Integral::NONE) {
    Console::decreaseIndention();
  }
  
  if (level_a > Integral::NONE) {
    SysString output(L"diagnostics passed for class");
    output.concat(name());
    output.concat(L"\n");
    Console::put(output);
  }
  
  // exit gracefully
  //
  return true;
}
