// file: $isip/class/search/Trace/trace_05.cc
// version: $Id: trace_05.cc,v 1.7 2003/01/24 15:26:13 alphonso Exp $
//

// isip include files
//
#include "Trace.h"

// method: setActive
//
// arguments:
//  boolean is_active: (input) defines the trace as active or inactive
//
// return: a boolean value indicating status
//
// this method sets the trace to be either active or inactive
//
boolean Trace::setActive(boolean is_active_a) {

  if (!is_active_a) {
    score_d = INACTIVE_SCORE;
  }
  else {
    if (score_d == INACTIVE_SCORE) {
      score_d = DEF_SCORE;
    }
  }
  return true;
}

// method: setBackPointer
//
// arguments:
//  Trace* back_ptr: (input) the trace to point back to
//
// return: a boolean value indicating status
//
// this method sets the trace's back pointer
//
boolean Trace::setBackPointer(Trace* back_ptr_a) {

  if (back_ptr_d != (Trace*)NULL) {
    back_ptr_d->decrementRefCount();
  }
  
  // set the new back pointer
  //
  back_ptr_d = back_ptr_a;
  if (back_ptr_d != (Trace*)NULL) {
    back_ptr_d->incrementRefCount();
  }

  // exit gracefully
  //
  return true;
}

// method: decrementRefCount
//
// arguments:
//  ulong decrement: (input) the number to decrement by 
//
// return: the reference count after decrementing
//
// this method decrements the reference count
//
ulong Trace::decrementRefCount(ulong decrement_a) {

  if (decrement_a > reference_count_d) {
    reference_count_d = 0;
  }
  else {
    reference_count_d -= decrement_a;
  }

  // exit gracefully
  //
  return reference_count_d;
}
