// file: $isip/class/stat/GaussianModel/gaus_01.cc
// version: $Id: gaus_01.cc,v 1.5 2001/01/13 02:09:01 picone Exp $
//

// isip include files
//
#include "GaussianModel.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: boolean value indicating status
//
// this is the debug method
//
boolean GaussianModel::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // output range information
  //
  Console::put(L"displaying mean_d:");
  Console::increaseIndention();
  mean_d.debug(L"mean_d");
  Console::decreaseIndention();

  Console::put(L"displaying covariance_d:");
  Console::increaseIndention();
  covariance_d.debug(L"covariance_d");
  Console::decreaseIndention();

  // output the scale factor and deviation
  //
  value.assign(scale_d);
  output.debugStr(name(), msg_a, L"scale_d", value);
  Console::put(output);

  Console::put(L"displaying deviation_d:");
  Console::increaseIndention();
  deviation_d.debug(L"deviation_d");
  Console::decreaseIndention();

  // output the computation mode information
  //
  output.debugStr(name(), msg_a, L"mode_d", MODE_MAP((ushort)mode_d));
  Console::put(output);
  
  value.assign(is_valid_d);
  output.debugStr(name(), msg_a, L"is_valid_d", value);
  Console::put(output);

  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
