;; file: $isip/login/editor_emacs_init.el
;;
;; this file creates some local customizations of emacs that are
;; considered standard parts of the isip environment.

;;---------------------------------------------------------------------------;;
;;                                                                           ;;
;; load shareware customizations first                                       ;;
;;                                                                           ;;
;;---------------------------------------------------------------------------;;

;; load url support
;;
(load-library "browse-url")

;;---------------------------------------------------------------------------;;
;;                                                                           ;;
;; load isip customizations last                                             ;;
;;                                                                           ;;
;;---------------------------------------------------------------------------;;

;; load the isip lisp code libraries
;;
(load-file (substitute-in-file-name
	    "$ISIP/login/editor_emacs_library_general.el"))

;; load the isip emacs modes
;;
(load-file (substitute-in-file-name
	    "$ISIP/login/editor_emacs_modes.el"))

;; load the isip custom key bindings
;;
(load-file (substitute-in-file-name
	    "$ISIP/login/editor_emacs_bindings.el"))

;; load the mime tools 
;;
;;(setq load-path 
;;      (cons (substitute-in-file-name "/usr/local/tm/share/emacs/site-lisp")
;;	    load-path))
;;(load "mime-setup")

;; tell the mime-editor not to split outgoing messages
;;
;;(add-hook 'mime/editor-mode-hook
;;	  '(lambda () (mime-editor/set-split nil)))

;; disable the menu-bar
;;
(menu-bar-mode nil)

;; turn on font-lock in all modes that support it
;;
(global-font-lock-mode 1)

;; turn on which-function-mode for all modes that support it
;;
(which-function-mode 't)

;; end of file
;;
