#!/bin/sh
# 

#---------------------------------------------------------------------------
# Local Variable Setup - Each user can modify these as necessary
#---------------------------------------------------------------------------
#
# Setup environmental variables
#
# define the default location of the isip tools
#
ISIP_DEVEL="/isip/d109/hamaker/tools"
ISIP="/isip/tools/ifc"

#---------------------------------------------------------------------------
# Global variable Setup - Do not edit these
#---------------------------------------------------------------------------
#
# Setup environmental variables
#
PATH=/bin:/usr/bin:/usr/local/bin
SHELL=/bin/sh

# verify the existence of the ISIP_DEVEL environment
#
:0
* ? test ! -d ${ISIP_DEVEL}
{ ISIP_DEVEL=$ISIP }

# location of the global include file
#
GLOBAL_INCLUDE_FILE=$ISIP_DEVEL/login/mail_procmailrc.sh

#---------------------------------------------------------------------------
# Local Variable Setup - Each user can modify these as necessary
#---------------------------------------------------------------------------
#
# Setup mail variables
#
MAILDIR=$HOME/mail/this_year            # you'd better make sure it exists

# Setup logging variables. You can turn VERBOSE on and off at different
# points in the file to only log what you want logged.
# LOG is the log entry separator
#
LOGFILE=$MAILDIR/procmail.log   # Use one or errors will be mailed to you
VERBOSE=no                      # recommended while debugging your rules
LOG="
"

# If you are forwarding your mail then include this, otherwise comment it
# out. For most people, wherever you see "! $FORWARD_ADDR" in the file
# below, you can replace that string with $DEFAULT, which will put the
# mail in /var/mail/<username> as usual. Both examples are given
#
FORWARD_ADDR=jhamaker@engr.msstate.edu

# Folder to put the spam in.
# It is a unix mail folder so you will need to use emacs movemail
# to read it in emacs. Similar to the way we do smail.mail and 
# smail.mail_new. An example spam.mail file is included in the 
# global scripts example directory. Put it in your $MAILDIR, open it in 
# emacs and hit 'g'.
#
SPAM_FOLDER=$MAILDIR/spam.mail_new

# whether or not to use backup files. These are a good idea at first to 
# insure that you do not lose mail. It will save copies of your received
# mail in the BACKUP_FOLDER directory. Either yes or no - case sensitive
#
USE_BACKUPS=no

# Folder to put backup files in - make sure it exists. 
#
BACKUP_FOLDER=$MAILDIR/backup

# whether to use the global spam filters. Either yes or no - case sensitive
#
USE_ISIP_SPAM_FILTERS=no
USE_SIMPLE_SPAM_FILTERS=no
USE_STRICT_SPAM_FILTERS=no

#---------------------------------------------------------------------------
# Custom user rules - pre spam filtering
#---------------------------------------------------------------------------
#
# Exception Filters: Legitimate email lists will be filtered out. Protect those
# that you want to keep receiving before they get to the spam filters.
# Examples are given below. Uncomment them to use.
#
#:0                    # CNN daily news sources
#* ^From.*cnn.*\.com
#$DEFAULT
#
#:0                    # ultimate mailing list
#* ^To.*ms-ultimate
#$DEFAULT

#---------------------------------------------------------------------------
# Spam filtering - use the global spam filters. Make sure you 
# have set $USE_ISIP_SPAM_FILTERS, $USE_SIMPLE_SPAM_FILTERS,
# and $USE_STRICT_SPAM_FILTERS
#
#---------------------------------------------------------------------------
#
# spam filtering recipes - these come right after backup up.
#
INCLUDERC=${GLOBAL_INCLUDE_FILE}

#---------------------------------------------------------------------------
# Custom user rules - post spam filtering
# Some things do get through even the strictest spam filters
# Add rules to do further filtering. A simple example below.
#
#---------------------------------------------------------------------------
#

# Remove Bounce messages from isip mailing lists
#
#:0:
#* ^Subject: .*BOUNCE .*@isip.msstate.edu:
#$SPAM_FOLDER

#---------------------------------------------------------------------------
# Default rule - everything that passes from above goes through this.
# If you are forwarding then use the version with FORWARD_ADDR.
# Otherwise use the version with DEFAULT
# 
#---------------------------------------------------------------------------
#
# this is the fall through for everything else - copy to /var/mail/<username>
#
:0:
$DEFAULT

# this is the fall through for everything else - forward to my desired account
#
#:0
#! $FORWARD_ADDR

