// file: $isip/util/diagnostics/diagnose_class/diagnose_class.h
// version: $Id:


// make sure definitions are only made once
//
#ifndef ISIP_DIAGNOSE_CLASS
#define ISIP_DIAGNOSE_CLASS

// isip include files 
//
#include <Error.h>
#include <Console.h>
#include <SysString.h>

// note: the class header file we are currently creating a diagnostic
// script for is automatically prepended to this file through the
// makefile.
//

// DIAG_CLASS_TYPE is the symbolic name of the class we are trying to
// make a diagnostic script for. this variable should have been
// defined by the make script,
//
//    make -DCLASS_NAME=Integral
//
#ifndef CLASS_NAME
#define CLASS_NAME YOU_MUST_DEFINE_A_CLASS_NAME
#endif

// define the debug level options
//
#define DEBUG_OPT "-debug"
#define DEBUG_OPT_NONE "NONE"
#define DEBUG_OPT_BRIEF "BRIEF"
#define DEBUG_OPT_DETAILED "DETAILED"
#define DEBUG_OPT_ALL "ALL"

// define the method to parse the command line
//
boolean readCmdline(int argc, char** argv, Integral::DEBUG& debug_level,
		    long& iteration);


// end of include file
//
#endif
