#! @SH@

# file: $isip/util/misc/isip_gimp/isip_gimp.sh
#
# The isip_gimp utility invokes the gnu image manipulation program setting the
# environment as needed by this program
#
# 02/01/99 (jon hamaker): first version
#

# make sure there is an isip environment - must be done at the top
#
if (test -z "$ISIP") then
    . $HOME/.bashrc;
fi

# important definitions
#
ISIP_PROGRAM_NAME="isip_gimp";

ISIP_HELP_FILE="$ISIP/util/misc/isip_gimp/isip_gimp.help";
export ISIP_HELP_FILE;

ISIP_DEFAULT_TOOL="gimp"

# execute a generic help function:
#  force the shellscript to exit if a help option is encountered.
set -e;
isip_function_help_0 $*;
set +e;

#  check if x is running
#
if (test ! "$DISPLAY") then
    echo "error($PROGRAM_NAME): $PROGRAM_NAME cannot run in terminal mode";
    exit $ISIP_ERROR;
else
    OPTIONS="";
fi

# we have a display and we didn't error off yet so we can begin to add things
# to the environment for running gimp
#
LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$ISIP_GIMP_LIB_PATH";
export LD_LIBRARY_PATH;

# run the gimp program
#
`nohup $ISIP_DEFAULT_TOOL $* 2>&1 > /dev/null ` &

# end of file
