// file: ConfigBox.java
//

// import java libraries
//
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.lang.*;
import javax.swing.plaf.*;

public class ConfigBoxArc extends JDialog implements ActionListener, 
						 ItemListener, Constants {

    // ---------------------------------------------------
    //
    // declare class member data
    //
    // ---------------------------------------------------

    // data from the parsed text file
    //
    Data data = null;
    
    // scroll pane to hold all the parameter fields
    //
    JScrollPane scroll_pane = null;

    // panel to hold all the config data fields
    // to be mounted in a scrollable pane
    //
    JPanel config_panel = null;
    
    // Button to get values an return to process design box
    //
    JButton save_button = null;
    JButton cancel_button = null;
    JButton default_button = null;
    JButton help_button = null;
    JButton config_button = null;    

    //Vector of labels and data blocks (text fields, selection blocks,
    //check boxes, etc..)
    //
    Vector enteredData = null;
    Vector blockType = null;
    Vector labelReference = null;

    //Vector of subclass vertices
    //
    Vector config_vertices = null;

    // Type of configuration box
    //
    int cfgType = 0;

    // arc index
    //
    int index = 0;
    
    // input Block Exist
    //
    boolean inputFlag = false;

    // Max number of subclasses
    //
    int max_subclass = 0;

    // vertex that is being configured
    //
    Vertex cfgVertexFocus = null;

    // WorkArea that allows the return button to do a proper repaint
    //
    WorkArea workArea = null;

    // jlabels used to lable each of the items in the config box
    //
    public Vector labels = null;

    // vectors user in a connector box configuration
    //
    Vector connBox = null;
    Vector connLabels = null;
    Vector connection_order = null;

    // DiGraph
    //
    DiGraph digraph;

    // ---------------------------------------------------
    //
    // declare class constructors
    //
    // ---------------------------------------------------

    // method: ConfigBox
    //
    // arguments: none
    // returns  : none
    //
    public ConfigBoxArc(DiGraph parent, Data d, Vertex b, WorkArea area, int type, int arcnum) {	      
	
	// invoke the parent default constructor
	//
	//super("Configuration Box");
	super(parent,"Configuration Box", true);

	digraph = parent;
	
	index = arcnum;

	Point xy = parent.getLocation();
	setLocation((int)xy.getX() + 100,(int)xy.getY() + 200);

	// Set the configuration type
	//
	cfgType = type;

	// Make the passed Data object available globally
	//
	data = d;
	
	// Initialize the enteredData and labelReference vectors for use
	//
	enteredData = new Vector(5,5);
	labelReference = new Vector(5,5);
	blockType = new Vector(5,5);
	
	// This is the vertex that is being configured
	//
	cfgVertexFocus = b;

	//Create this new panel with gridbag layout
	//
	config_panel =  new JPanel();
	addConfig();

	// make reference available globally for work area
	//
	workArea = area;
	
	//Set the sizes of the scroll pane and configuration panel
	//
	int height = (labelReference.size()+2) * 25  + 70;
	int width = 335 + 55;

	config_panel.setSize(width,height);
	config_panel.setMinimumSize(new Dimension(width,height));
	config_panel.setPreferredSize(new Dimension(width,height));
	config_panel.setMaximumSize(new Dimension(width,height));

	//  create the appropriate string for the border
	//
	String border_title = null;
	if(cfgType == 0)
	    border_title = 
		new String(" Arc Parameters");
	else if (cfgType == 1){
	    border_title = 
		new String("Connector Configuration:");
	}

	// create the border and set the proper font
	//
	BorderUIResource.TitledBorderUIResource border =
	    new BorderUIResource.TitledBorderUIResource(border_title);
	border.setTitleFont(newFont);
	border.setTitleColor(Color.black);

	// make the config panel use the proper border
	//
	config_panel.setBorder(border);

	//Add the scroll pane to the frame
	//
	this.getContentPane().add(config_panel, BorderLayout.NORTH);
    }

    
    // ---------------------------------------------------
    //
    // declare class methods
    //
    // ---------------------------------------------------

    // method:  addConfig()
    //
    // arguments:  none
    // return: none
    //
    //  dynamically adds and constrains all objects on the JPanel
    //
    public void addConfig() {


	//  make this config panel use grid bag layout
	//
	GridBagLayout gridbag = new GridBagLayout();
	config_panel.setLayout(gridbag);

	// create from vertex labels to be included in the arc
	//
	JLabel fromLabel = new JLabel("from: ");
	fromLabel.setFont(newFont);
	fromLabel.setForeground(Color.black);
	constrain(config_panel,fromLabel, gridbag, 0, 0,
			  1, 1, 1, 0, GridBagConstraints.WEST);

	Vertex fromv = null;
	fromv = (Vertex)digraph.graphArc.from.get(index);
	String fromname = null;
	JTextField fvertexField = new JTextField(fromv.getVertexName(), 8);
	fvertexField.setEditable(false);
	fvertexField.setFont(newFont);
	fvertexField.setForeground(Color.black);
	constrain(config_panel,fvertexField, gridbag, 3, 0,
		  1, 1, 1, 0, GridBagConstraints.EAST);

	// create to vertex labels to be included in the arc
	//
	JLabel toLabel = new JLabel("to: ");
	toLabel.setFont(newFont);
	toLabel.setForeground(Color.black);
	constrain(config_panel,toLabel, gridbag, 0, 1,
			  1, 1, 1, 0, GridBagConstraints.WEST);

	Vertex tov = null;
	tov = (Vertex)digraph.graphArc.to.get(index);
	String toname = null;
	JTextField tvertexField = new JTextField(tov.getVertexName(), 8);
	tvertexField.setEditable(false);
	tvertexField.setFont(newFont);
	tvertexField.setForeground(Color.black);
	constrain(config_panel,tvertexField, gridbag, 3, 1,
		  1, 1, 1, 0, GridBagConstraints.EAST);


	// add the appropriate input values depending on whether the 
	// vertex being configured in a transform or a connector
	//
	if(cfgType == 0) {
	    //addTransformConfig(gridbag);
	    addArcConfig(gridbag);
	}
	else if (cfgType == 1){
	    addConnectorConfig(gridbag);
	}

	// create a button panel to place all buttons on so proper spacing 
	// can be acheived
	//	
	JPanel button_panel = new JPanel();
	button_panel.setLayout(new GridLayout(1,4, 1, 1));

	// create the return button and add the appropriate action handler
	//
	save_button = new JButton("Save");
	button_panel.add(save_button);
	save_button.addActionListener(this);
	save_button.setActionCommand("update");
	save_button.setFont(newFont);
	
	// create the cancel button and add to subpanel
	//
	cancel_button = new JButton("Cancel");
	button_panel.add(cancel_button);
	cancel_button.addActionListener(this);
	cancel_button.setActionCommand("cancel");
	cancel_button.setFont(newFont);

	// create the default button and add to subpanel
	//
	default_button = new JButton("  Default ");
	button_panel.add(default_button);
	default_button.addActionListener(this);
	default_button.setActionCommand("default");
	default_button.setFont(newFont);

	// create the help button and add to subpanel
	//
	help_button = new JButton("Help");
	button_panel.add(help_button);
	help_button.addActionListener(this);
	help_button.setActionCommand("help");
	help_button.setFont(newFont);	

	// place the button panel onto the config panel
	//
	constrain(config_panel, button_panel, gridbag, 0, labels.size()+1,
		  GridBagConstraints.REMAINDER,1,1,1,
		  GridBagConstraints.SOUTH);

    }
   
    // method: addConnectorConfig
    //
    // arguments:
    //    GridBagLayout gridbag:  gridbag layout for config panel
    //
    // return   : none
    //
    //  places all the proper input items onto the config panel 
    //  for configuring a connector box
    //
    public void addConnectorConfig(GridBagLayout gridbag)  {
	
	// get the number of parents this connector vertex has
	//
	int size = cfgVertexFocus.getInDegree();
	
	// create a vector containing the names of all the connector's 
	// parents
	//
	labels = new Vector(5,5);

	// populate the names vector
	//
	for(int i=0; i < size; i++) {
	    Vertex vertex_parent = (Vertex)cfgVertexFocus.vertexParents.get(i);
	    String vertex_name = vertex_parent.getVertexName();
	    labels.add((i + 1) + ":" + vertex_name);
	}

	// create a vector of JLabels and JComboBox for use in swapping
	//
	connLabels = new Vector(size,1);
	connBox = new Vector(size,1);
	connection_order = new Vector(size,1);

	// populate the vector's for display 
	//
	for(int i=0; i < labels.size(); i++) {
	    connLabels.add(new JLabel("Position " + (i+1)));
	    connBox.add(new JComboBox(labels));
	    ((JComboBox)connBox.get(i)).setSelectedIndex(i);
	    ((JComboBox)connBox.get(i)).addItemListener(this);
	}
	
	for(int i=0; i < labels.size(); i++) {
	  
	    // place the label onto the screen
	    //
	    ((JLabel)connLabels.get(i)).setForeground(Color.black);
	    constrain(config_panel,(JLabel)(connLabels.get(i)), gridbag, 0, i,
		      1, 1, 1, 0, GridBagConstraints.WEST);
	    ((JLabel)connLabels.get(i)).setFont(newFont);
	    labelReference.add((JLabel)connLabels.get(i));

	    // place the JComboBox on the screen
	    //
	    ((JComboBox)connBox.get(i)).setForeground(Color.black);
	    constrain(config_panel,((JComboBox)connBox.get(i)), gridbag, 1, i,
		      1, 1, 1, 0, GridBagConstraints.EAST);
	    ((JComboBox)connBox.get(i)).setFont(newFont);

	    // populate a vector to tell me connections made
	    //
	    Integer integer = new Integer(i);
	    connection_order.add(integer);
	}
    }

    // method: addArcConfig
    //
    // arguments:
    //    GridBagLayout gridbag:  gridbag layout for config panel
    //
    // return   : none
    //
    //  places all the proper input items onto the config panel 
    //  for configuring any transform
    //
    public void addArcConfig(GridBagLayout gridbag)  {

	labels = new Vector(5,5);
	
	// create labels to be included in the frame
	//
	JLabel weightLabel = new JLabel("Weight: ");
	weightLabel.setFont(newFont);
	weightLabel.setForeground(Color.black);
	labelReference.add(weightLabel);
		constrain(config_panel,weightLabel, gridbag, 0, 2,
			  1, 1, 1, 0, GridBagConstraints.WEST);
	labels.add("Weight");
	String tmpw = null;
	tmpw = (String)digraph.graphArc.weights.get(index);
	JTextField weightField = null; 
	if(tmpw != null) {
	    	weightField = new JTextField(tmpw, 8);
	}
	else {
	    weightField = new JTextField("1.0", 8);
	}
	weightField.setFont(newFont);
	weightField.setForeground(Color.black);
	constrain(config_panel,weightField, gridbag, 3, 2,
		  1, 1, 1, 0, GridBagConstraints.EAST);

	enteredData.add(weightField);
	blockType.add("float");
	
	JLabel epiLabel = new JLabel("Epsilon: ");
	labels.add("Epsilon");
	epiLabel.setFont(newFont);
	epiLabel.setForeground(Color.black);
	labelReference.add(epiLabel);
	constrain(config_panel,epiLabel, gridbag, 0, 3,
		  1, 1, 1, 0, GridBagConstraints.WEST);
		
	// create the check box
	//
	boolean value2 = false;
	
	String tmpe = null;
	tmpe = (String)digraph.graphArc.epsilon.get(index);
	JCheckBox checkBox = null;

	// instantiate and place chack box on config panel
	//
	if(tmpe == "true") {
	    checkBox = new JCheckBox("", true);
	}
	else {
	    checkBox = new JCheckBox("", value2);
	}
	constrain(config_panel, checkBox, gridbag, 3, 3,
		  1,1,1,0,GridBagConstraints.EAST);
	enteredData.add(checkBox);
	blockType.add("boolean");

    }



    // method: addTransformConfig
    //
    // arguments:
    //    GridBagLayout gridbag:  gridbag layout for config panel
    //
    // return   : none
    //
    //  places all the proper input items onto the config panel 
    //  for configuring any transform
    //
    public void addTransformConfig(GridBagLayout gridbag)  {
	
	// to simplify the creation, the data vectors will be trimmed to only
	// include the transform we're looking at and saved into these three
	// vectors for use in a bit
	//
	labels = new Vector(5,5);
	Vector types = new Vector(5,5);
	Vector values = new Vector(5,5);
	String transform = cfgVertexFocus.association;
	int subclassIndex = 0;

	for(int j=data.association.indexOf(transform); 
	    j <= data.association.lastIndexOf(transform);
	    j++) {
	    if(j != -1) {
		labels.add(data.name.get(j));
		types.add(data.type.get(j));
		values.add(data.values.get(j));
	    }
	}
	
	// calculate the total number of subclasses
	//
	for(int i =0; i < types.size(); i++){
	    if(types.get(i).equals("class"))
		max_subclass++;
	}
	
	// maximum width of any JTextField or JComboBox
	// will set all to this width once they have been added
	//
	int maxwidth = 0;
	int maxheight = 0;
	
	// run through these and add labels and input fields as appropriate
	//
	for(int i=0; i < labels.size(); i++) {

	    // add a label for all labels except the images
	    //
	    if(types.get(i).equals("image") == false){
		JLabel jlabel = new JLabel((String)labels.get(i));
		jlabel.setForeground(Color.black);
		constrain(config_panel,jlabel, gridbag, 0, i,
			  1, 1, 1, 0, GridBagConstraints.WEST);
		labelReference.add(jlabel);
		jlabel.setFont(newFont);	    
	    }
	    else {
	
		// keep data alligned so changing values is done easily
		// while holding onto these image files
		//
		enteredData.add("image");
		labelReference.add("image");
		blockType.add("image");
	    }
	    
	    // add a drop down list for the enumerated values with first
	    // option from file being initially selected
	    //
	    if(types.get(i).equals("enum")){
		
		// create a drop down list to allow selection from
		//
		JComboBox select = new JComboBox();
		select.setFont(newFont);
		select.setForeground(Color.black);

		// retrieve and add all possible values to this list
		//
		Vector enum_values = (Vector)values.get(i);

		for(int j=0; j < enum_values.size(); j++) {
		    select.addItem(enum_values.get(j));
		}
		
		// add the combo box to the panel
		//
		constrain(config_panel,select, gridbag, 3, i,
			  1, 1, 1, 0, GridBagConstraints.EAST);
		enteredData.add(select);
		blockType.add("enum");
		Vertex selectedVertex = cfgVertexFocus;
		select.setSelectedItem(selectedVertex.values.get(i));
	    }
	    
	    // make a check box for a boolean type
	    //
	    else if (types.get(i).equals("boolean")){
		
		// create the check box
		//
		String value = (String)(cfgVertexFocus.values.get(i));
		
		// get the default value for the button
		//
		boolean value2;
		if (value.equals( "true"))
		    value2 = true;
		else
		    value2 = false;
		
		// instantiate and place chack box on config panel
		//
		JCheckBox checkBox = new JCheckBox("", value2);
		constrain(config_panel, checkBox, gridbag, 3, i,
			  1,1,1,0,GridBagConstraints.EAST);
		enteredData.add(checkBox);
		blockType.add("boolean");
	    }
	    
	    // add another pop up frame to set parameters for the class
	    //
	    else if (types.get(i).equals("class")) {

		Vertex button;
		if(cfgVertexFocus.max_subclass > cfgVertexFocus.subclass.size()) {
		    String image_name = null;
		    String image_association= null;

		    // tells the program which transform it is looking to match
		    //
		    image_association = (String)values.get(i);

		    // scans through the association until it 
		    // finds the smallIcon key
		    //
		    for(int j=data.association.indexOf(image_association); 
			j <= data.association.lastIndexOf(image_association);
			j++) {
			if(j != -1) {
			    
			    if(((String)(data.name.get(j))).
			       equals("iconSmall")) {
		
				// sets the image_name to the value 
				// held in small icon
				//
				image_name = (String)data.values.get(j);
			    }
			}
		    }
		    
		    // check to see if the file exists. If it does not exist,
		    // use a default image.
		    //
		    if(image_name != null){
			File image_file = new File(image_name);
			if (image_file.exists() == false)
			    image_name = GUI_PATH + "/images_small/default.gif";
		    }
		    else {
			image_name = GUI_PATH + "/images_small/default.gif";
		    }

		    // create the icons for the config panel
		    //
		    ImageIcon icon = new ImageIcon(image_name);
		    
		    // create the button for the config panel
		    //
		    button = new Vertex(icon, ALGORITHM);
		    
		    // to simplify the creation, the data vectors will 
		    // be trimmed to only include the transform we're
		    // looking at and saved into these three vectors
		    // for use in a bit
		    //
		    Vector labels2 = new Vector(5,5);
		    Vector types2 = new Vector(5,5);
		    Vector values2 = new Vector(5,5);
		    
		    for(int j=data.association.indexOf(image_association); 
			j <= data.association.lastIndexOf(image_association);
			j++) {
			if(j != -1) {
			    labels2.add(data.name.get(j));
			    types2.add(data.type.get(j));
			    values2.add(data.values.get(j));
			}
		    }
		    	 
		    // initialize the vertex to the default values for its type
		    //
		    button.initializeConfig(labels2, values2, types2,
					    image_association, data);
		   
		    // add subclass button to the vector
		    //
		    cfgVertexFocus.subclass.add(button);
		    
		    // attach an action listener to the button
		    //
		    button.setActionCommand("class");
		    button.addActionListener(this);
		}
		else {
		    
		    // bring back the saved button if all class button's have 
		    // been previously saved
		    //
		    button = (Vertex)cfgVertexFocus.subclass.get(subclassIndex);
		    if (button.actionAdded == false){
			button.addActionListener(this);
			button.actionAdded = true;
		    }
		    subclassIndex++;
		}
		
		// add the vertex to the button panel
		//
		constrain(config_panel,button, gridbag, 3, i,
			  1, 1, 1, 0, GridBagConstraints.EAST);
		enteredData.add(button);
		blockType.add("Vertex");
	    }
	    
	    // do nothing if the type is image
	    //
	    else if (types.get(i).equals("image")) {
	    }
	    
	    // take care of type text
	    //
	    else if (types.get(i).equals("text")) {
		JTextField TextField = 
		    new JTextField(((String)cfgVertexFocus.values.get(i)), 8);
		TextField.setFont(newFont);
		TextField.setForeground(Color.black);
		constrain(config_panel,TextField, gridbag, 3, i,
			  1, 1, 1, 0, GridBagConstraints.EAST);
		enteredData.add(TextField);
		blockType.add("text");
	    }

	    // take care of type vector
	    //
	    else if (types.get(i).equals("vector")) {
		JTextField TextField = 
		    new JTextField(((String)cfgVertexFocus.values.get(i)), 8);
		TextField.setFont(newFont);
		TextField.setForeground(Color.black);
		constrain(config_panel,TextField, gridbag, 3, i,
			  1, 1, 1, 0, GridBagConstraints.EAST);
		enteredData.add(TextField);
		blockType.add("vector");
	    }
	    
	    // creation of input box for unsigned int
	    //
	    else if (types.get(i).equals("unsigned-integer")) {
		JTextField TextField = 
		    new JTextField(((String)cfgVertexFocus.values.get(i)), 8);
		TextField.setFont(newFont);
		TextField.setForeground(Color.black);
		constrain(config_panel,TextField, gridbag, 3, i,
			  1, 1, 1, 0, GridBagConstraints.EAST);
		enteredData.add(TextField);
		blockType.add("unsigned-integer");
	    }

	    // creation of input box for float
	    //
	    else if (types.get(i).equals("float")) {
		if (!(labels.get(i).equals("signal_duration") && inputFlag)) {
		    JTextField TextField = 
			new JTextField(((String)cfgVertexFocus.values.get(i)), 8);
		    TextField.setFont(newFont);
		    TextField.setForeground(Color.black);
		    constrain(config_panel,TextField, gridbag, 3, i,
			      1, 1, 1, 0, GridBagConstraints.EAST);
		    enteredData.add(TextField);
		    blockType.add("float");
		}
		else {
		    //blockType.add("float");
		}
	    } 

	    // creation of input box for double
	    //
	    else if (types.get(i).equals("double")) {
		JTextField TextField = 
		    new JTextField(((String)cfgVertexFocus.values.get(i)), 8);
		TextField.setFont(newFont);
		TextField.setForeground(Color.black);
		constrain(config_panel,TextField, gridbag, 3, i,
			  1, 1, 1, 0, GridBagConstraints.EAST);
		enteredData.add(TextField);
		blockType.add("double");
	    } 

	    // creation of input box for int
	    //
	     else if (types.get(i).equals("integer")) {
		 JTextField TextField = 
		     new JTextField(((String)cfgVertexFocus.values.get(i)), 8);
		 TextField.setFont(newFont);
		 TextField.setForeground(Color.black);
		 constrain(config_panel,TextField, gridbag, 3, i,
			   1, 1, 1, 0, GridBagConstraints.EAST);
		 enteredData.add(TextField);
		 blockType.add("integer");
	     } 

	    // !!! unexpected data type
	    //
	    else {
		System.err.println();
		System.err.println("---------------------------------------");
		System.err.println("Error - Unexpected data type in file resource.txt: " + types.get(i));
		System.err.println("---------------------------------------");
		System.exit(0);
	    }

	    // check to see if the width of a JComboBox or JTextField
	    // is wider than maxwidth and if it is, give that value to 
	    // maxwidth
	    //
	    String type = (String)blockType.get(i);
	    if((!type.equals("Vertex") &&
		(!type.equals("image")) &&
		(!type.equals("input")) &&
		(!type.equals("boolean")))) {
		
		Dimension size = (Dimension)((JComponent)enteredData.
					     get(i)).getPreferredSize();
		int width = (int)size.getWidth();
		int height = (int)size.getHeight();
		if( width > maxwidth) {
		    maxwidth = width;
		    maxheight = height;
		}
	    }
	}
	
	// make all of the JComboBoxes and JTextFields be of equal length
	//
	for(int i = 0; i < blockType.size(); i++) {
	    String type = (String)blockType.get(i);
	    if((!type.equals("Vertex") &&
		(!type.equals("image")) &&
		(!type.equals("input")) &&
		(!type.equals("boolean")))) {
		Dimension size = new Dimension(maxwidth, maxheight);
		((JComponent)enteredData.get(i)).
		    setPreferredSize(size);
		((JComponent)enteredData.get(i)).
		    setMinimumSize(size);
	    }
	}
    }

    // method: constrain
    //
    // arguments:
    //    JPanel container      :  panel being added to
    //    Component button      :  what is being added to the panel
    //    GridBagLayout gridbag :  gridbag layout for config panel
    //    int gridx             :  the x grid position of the constraint
    //    int gridy             :  the y grid position of the constraint
    //    int gridwidth         :  the number of gridspaces wide to constrain
    //    int gridheight        :  the number of gridspaces tall to constrain
    //    int weightx           :  the horizontal weighting of the constraint
    //    int weighty           :  the vertical weighting of the constraint
    //    int anchor            :  which side of the constraint to anchor to
    //
    // return  :  none
    //
    //  places all the proper input items onto the config panel 
    //  for configuring any transform
    // 
    public void constrain(JPanel container,Component button, 
			  GridBagLayout gridbag, int gridx,int gridy, 
			  int gridwidth, int gridheight,
			  int weightx, int weighty, int anchor){
	GridBagConstraints c = new GridBagConstraints();
	c.gridx = gridx;
	c.gridy = gridy;
	c.gridwidth = gridwidth;
	c.gridheight = gridheight;
	c.weightx = weightx;
	c.weighty = weighty;
	c.anchor = anchor;
	gridbag.setConstraints(button, c);
	container.add(button);
    }

    // method: validation
    //
    // arguments:  none
    //
    // return:  boolean 
    //
    // checks to make sure that all configuration data has been input properly
    // and if it has, make the changes to the referrign vertex 
    // 
    public boolean validation() {

	for(int i=0; i < labelReference.size(); i++) {
	    
	    // code to use if the data is an enumerated type
	    //
	    if(blockType.get(i).equals("enum")) {
		
		// set the vertex's value to match the newly selected one
		//
		cfgVertexFocus.values.set(i,
			(String)((JComboBox)enteredData.get(i)).
				     getSelectedItem());
	    }

	    // code to use if the data is a text field
	    //
	    if(blockType.get(i).equals("text")) {
		String text =((JTextField)enteredData.get(i)).getText();
		text = text.trim();
		cfgVertexFocus.values.set(i,text);
	    }

	    // code to use if the data is a vector field
	    //
	    if(blockType.get(i).equals("vector")) {
		String text =((JTextField)enteredData.get(i)).getText();
		text = text.trim();
		cfgVertexFocus.values.set(i,text);
	    }

	    // code to get information from a check box
	    //
	    if(blockType.get(i).equals("boolean")) {

		boolean status = ((JCheckBox)enteredData.get(i)).isSelected();
		String value = new String();
		if(status){
		    value = "true";
		}
		else {
		    value = "false";
		}

		digraph.tmpepi = "" + value;
		//cfgVertexFocus.values.set(i,value);
	    }
	    
	    // code to get information from a float variable
	    //
	    if(blockType.get(i).equals("float")) {
		
		String text = ((JTextField)enteredData.get(i)).getText();
		try {
		    float value = Float.valueOf(text).floatValue();
		    //cfgVertexFocus.values.set(i, text);
		    //System.out.println("text="+ text);
		    digraph.tmpweight = ""+text;
		}
		catch (java.lang.NumberFormatException event) {
		    JFrame frame = new JFrame("Warning");
		    String warningMessage = new 
			String("The value entered for " + 
			       cfgVertexFocus.names.get(i) + 
			       " is not a floating point number.");
		    JOptionPane.showMessageDialog(frame, warningMessage);
		    return false;
		}
	    }

	    // code to get information from a double variable
	    //
	    if(blockType.get(i).equals("double")) {
		String text = ((JTextField)enteredData.get(i)).getText();
		try {
		    double value = Double.valueOf(text).doubleValue();
		    cfgVertexFocus.values.set(i, text);
		}
		catch (java.lang.NumberFormatException event) {
		    JFrame frame = new JFrame("Warning");
		    String warningMessage = new 
			String("The value entered for " + 
			       cfgVertexFocus.names.get(i) + 
			       " is not a floating point number.");
		    JOptionPane.showMessageDialog(frame, warningMessage);
		    return false;
		}
	    }
	    
	    // code to get information from an unsigned integer variable
	    //
	    if(blockType.get(i).equals("unsigned-integer")) {
		String text = ((JTextField)enteredData.get(i)).getText();
		try {
		    int value = Integer.valueOf(text).intValue();
		    if (value >= 0) {
			cfgVertexFocus.values.set(i, text);
		    } else {
			JFrame frame = new JFrame("Warning"); 
			String warningMessage = new 
			    String("The value entered for " + 
				   cfgVertexFocus.names.get(i) + 
				   " is not an unsigned integer.");
			JOptionPane.showMessageDialog(frame,warningMessage);
			return false;
		    }
		}
		catch (java.lang.NumberFormatException event) {
		    JFrame frame = new JFrame("Warning");
		    String warningMessage = new 
			String("The value entered for " + 
			       cfgVertexFocus.names.get(i) + 
			       " is not an unsigned integer.");
		    JOptionPane.showMessageDialog(frame, warningMessage);
		    return false;
		}
	    }

	    // code to get information from an integer variable
	    //
	    if(blockType.get(i).equals("integer")) {
		String text = ((JTextField)enteredData.get(i)).getText();
		try {
		    int value = Integer.valueOf(text).intValue();
		    cfgVertexFocus.values.set(i, text);
		}
		catch (java.lang.NumberFormatException event) {
		    JFrame frame = new JFrame("Warning");
		    String warningMessage = new 
			String("The value entered for " + 
			       cfgVertexFocus.names.get(i) + 
			       " is not an integer.");
		    JOptionPane.showMessageDialog(frame, warningMessage);
		    return false;
		}
	    }
	}
	return true;
    }

    // method: itemStateChanged
    //
    // arguments:  
    //     ItemEvent e:  event thrown when one of the combo boxes is changed
    //
    // return:  boolean 
    //
    // prevents duplicates from being formed when changing the order in 
    // a connector configuration screen
    // 
    public void itemStateChanged(ItemEvent e) {
	
	// the combo box that caused the event to fire
	//
	JComboBox changedBox = (JComboBox)e.getSource();
	
	// the value that the box was changed to
	//
	int newSetting = changedBox.getSelectedIndex();
	
	// holds the index of the combo box that called this even handler
	//
	int newSettingIndex = -1;
	
	// the value the box was changed from
	//
	int oldSetting = -1;
	
	// the index of the combo box that is set to what the other combo box
	// was changed to
	//
	int oldSettingIndex = -1;

	for(int i=0; i < connBox.size(); i++) {
	    
	    // gets the value of the currently selected combo box
	    //
	    int needToChange = ((JComboBox)connBox.get(i)).getSelectedIndex();
	    
	    // if the new setting is equal to the value that the box is being
	    // changed to, this is either the box that was changed or the one
	    // that needs to be changed 
	    //
	    if (newSetting == needToChange) {
		// gets the value that the combobox was set to before changes
		// were made to it
		//
		int change = ((Integer)connection_order.get(i)).intValue();
		
		// if these are equal, we are dealing with the combo box
		// that was not changed
		//
		if ((newSetting == change) && (newSettingIndex == -1)) {
		    newSettingIndex = i;
		}
		
		// if these are not equal, then this is the one that was 
		// changed
		//
		if ((newSetting != change ) && (oldSettingIndex == -1)) {
		    oldSettingIndex = i;
		    oldSetting = change;
		}
		
		// if we've found both the one that are involved in the change
		// make the changes
		//
		if ((newSettingIndex != -1)&&(oldSettingIndex != -1)) {
		
		    // changes the combo box so that there are no 
		    // duplicate inputs
		    //
		    ((JComboBox)connBox.get(newSettingIndex)).
			setSelectedIndex(oldSetting);
		    
		    // corrects the connection order vector to show the 
		    // new order of the inputs
		    //
		    Integer value = new Integer(oldSetting);
		    connection_order.set(newSettingIndex, value);
		    
		    Integer value2 = new Integer(newSetting);
		    connection_order.set(oldSettingIndex, value2);
		    
		    return;
		}
	    }
	}
    }
    
    // method: actionPerformed
    //
    // arguments:
    //    ActionEvent e: event that was fired
    //
    // return   : none
    //
    // listens for actions taking place on the components
    //
    public void actionPerformed(ActionEvent e) {
	
	if(e.getActionCommand().equals("update")){
	
	    // if the block we've configured is a transform
	    //
	    if(cfgType == 0) {
		
		// validate the inputs and if they are all valid, 
		// dispose of the box
		//		
		if(validation()) {
		    this.dispose();
		    workArea.repaint();
		}
	    }
	    
	    // if the block being congifured is a connector block
	    //
	    else if(cfgType == 1) {
		
		// make a copy of the parent vector for this connector
		//
		Vector parentCopy = new Vector(cfgVertexFocus.getParents());
	
		// change all connections as the config box has told
		//
		for(int i=0; i < connBox.size(); i++) {
		    
		    // get the combo box in question
		    //
		    JComboBox focus = (JComboBox)connBox.get(i);
		    int selected_index = focus.getSelectedIndex();

		    // change the connector from the selected source to 
		    // the position it wanted in
		    //
		    cfgVertexFocus.changeConnectors((i + 1),
						    (Vertex)parentCopy.
						    get(selected_index));
		}
		
		// close the window and repaint the workArea
		//
		this.dispose();
		workArea.repaint();
	    }
	}
	
	if(e.getActionCommand().equals("cancel")){

	    digraph.tmpweight = (String)digraph.graphArc.weights.get(index);
	    digraph.tmpepi = (String)digraph.graphArc.epsilon.get(index);

	    // dispose of the changes and revert to the old ways
	    //
	    this.dispose();
	}
	
	if(e.getActionCommand().equals("default")){
	    defaultSettings();
	}
	
	if(e.getActionCommand().equals("revert")){
	    revertSettings();
	}
	
	if(e.getActionCommand().equals("help")){
		
	    // display a help message: "under construction"
	    //
	    JFrame frame = new JFrame("Help");
	    JOptionPane.showMessageDialog(frame, 
					  "The help message is under construction");
	}
	
	// create config window if dealing with a nested class for config
	//
	if(e.getActionCommand().equals("class")){
	    Vertex temp = (Vertex)e.getSource();
	    /*
	    SubConfigBoxSys class_config_panel = 
		new SubConfigBoxSys(data, temp, cfgVertexFocus);
	    class_config_panel.pack();
	    class_config_panel.setVisible(true);
	    */
	}
    }

    // method: defaultSettings
    //
    // arguments:  none
    //
    // return:  none
    //
    //  resets all configuartion items to the default values as given in 
    //  the gui configuration file
    //
    public void defaultSettings() {

	if(cfgType == 0) {
	      
	    JTextField text_box
		= (JTextField)enteredData.get(0);
	    text_box.setText("1.0");

	    boolean value2 = false;
	    
	    // actually make the change to the check box
	    //
	    JCheckBox checkBox = 
		(JCheckBox)enteredData.get(1); 
	    checkBox.setSelected(value2);
	    
	}
	else if(cfgType == 1) {
	    for(int i=0; i < connBox.size(); i++) {
		
		// set all the combo boxes to show their original values
		//
		((JComboBox)connBox.get(i)).setSelectedIndex(i);
		
		// reset the connection order vector to the original setting
		//
		Integer value = new Integer(i);
		connection_order.set(i, value);
	    }
	}
    }

    // method: revertSettings
    //
    // arguments:  none
    //
    // return:  none
    //
    //  resets all configuartion items to the values that were stored in the 
    //  referring vertex before the configuration began 
    //    
    public void revertSettings() {
	
	// changes all of the settings back to what they were before the 
	// user started changing things
	//
	if(cfgType == 1) {
	    for(int i=0; i < connBox.size(); i++) {
		
		// set all the combo boxes to show their original values
		//
		((JComboBox)connBox.get(i)).setSelectedIndex(i);
		
		// reset the connection order vector to the original setting
		//
		Integer value = new Integer(i);
		connection_order.set(i, value);
	    }
	}
	else if(cfgType == 0) {
	
	    // now run through these and add labels and input 
	    // fields as appropriate
	    //
	    for(int i=0; i < cfgVertexFocus.values.size(); i++) {
		// make the selected option revert to its previous state
		//
		if(cfgVertexFocus.types.get(i).equals("enum")){
		    
		    JComboBox select = (JComboBox)enteredData.get(i);
		    select.setSelectedItem(cfgVertexFocus.values.get(i));
		}
		
		// make the check box revert to its previous state
		//
		else if (cfgVertexFocus.types.get(i).equals("boolean")){
		
		    // get the value for the check box
		    //
		    String value = (String)(cfgVertexFocus.values.get(i));
		    JCheckBox checkBox = (JCheckBox)enteredData.get(i); 

		    boolean value2;
		    if (value.equals("true"))
			value2 = true;
		    else
			value2 = false;
		    checkBox.setSelected(value2);
		}
		
		// do nothing if the type is image
		//
		else if (cfgVertexFocus.types.get(i).equals("image")) {
		}
		
		// do nothing if type is class
		//
		else if (cfgVertexFocus.types.get(i).equals("class")) {
		}
		
		// take care of anything of type text
		//
		else if (cfgVertexFocus.types.get(i).equals("text")) {
		    
		    JTextField text_box = (JTextField)enteredData.get(i);
		    String text = (String)cfgVertexFocus.values.get(i);
		    text_box.setText(text);
		    
		}

		// creation of input box for unsigned int
		//
		else if (cfgVertexFocus.types.get(i).equals("unsigned-integer")) {
		    
		    JTextField text_box = (JTextField)enteredData.get(i);
		    String text = (String)cfgVertexFocus.values.get(i);
		    text_box.setText(text);	    
		}
		
		// creation of input box for float
		//
		else if (cfgVertexFocus.types.get(i).equals("float")) {
		    
		    JTextField text_box = (JTextField)enteredData.get(i);
		    String text = (String)cfgVertexFocus.values.get(i);
		    text_box.setText(text);
		}
		
		// creation of input box for int
		//
		else if (cfgVertexFocus.types.get(i).equals("integer")) {
		    
		    JTextField text_box = (JTextField)enteredData.get(i);
		    String text = (String)cfgVertexFocus.values.get(i);
		    text_box.setText(text);	    
		}
	    }
	} 
    }
}

//
// end of file























